/*
 * PM - 2016
 * lab0.c
 */
#define F_CPU 16000000

#include <util/delay.h>
#include <avr/io.h>
#include <stdio.h>
#include <stdlib.h>

#include "spi.h"
#include "lcd8x8rgb.h"

//Defining key ports
#define KEY_DDR     DDRA
#define KEY_PORT    PORTA
#define KEY_PIN     PINA
#define KEY_LEFT			0
#define KEY_RIGHT			1
#define KEY_UP				2
#define KEY_DOWN			3
#define KEY_ENTER			4

unsigned char start_msg[] = "Start game!";
bool point = 1;

void init() {
	setDataMode(SPI_MODE1);
	setClockDivider(SPI_CLOCK_DIV64);
	begin();
	
	DDRA |= (1 << LATCH);
	LATCH_PORT &= ~(1<<LATCH);
	vClear();
}


ISR(PCINT0_vect)
{
	// PB0 apasat
	if((KEY_PIN & (1 << KEY_RIGHT)) == 0)
	{
		PORTD &= ~(1 << PD7);
	}
	else
		// Sting LED-ul.
		PORTD &= ~(1 << PD7);
	
	if((KEY_PIN & (1 << KEY_LEFT)) == 0)
	{
		PORTD |= (1 << PD7);
	}
	else
	// Sting LED-ul.
	PORTD &= ~(1 << PD7);
	
	if((KEY_PIN & (1 << KEY_UP)) == 0)
	{
		PORTD |= (1 << PD7);
	}
	else
	// Sting LED-ul.
	PORTD &= ~(1 << PD7);
	
	if((KEY_PIN & (1 << KEY_DOWN)) == 0)
	{
		PORTD |= (1 << PD7);
	}
	else
	// Sting LED-ul.
	PORTD &= ~(1 << PD7);
	
	if((KEY_PIN & (1 << KEY_ENTER)) == 0)
	{
		PORTD |= (1 << PD7);
	}
	else
	// Sting LED-ul.
	PORTD &= ~(1 << PD7);
}

void init_io(void){
	//Button
	KEY_DDR &= ~((1<<KEY_RIGHT)|(1<<KEY_LEFT)|(1<<KEY_UP)|(1<<KEY_DOWN)|(1<<KEY_ENTER));
	KEY_PORT |= (1<<KEY_RIGHT)|(1<<KEY_LEFT)|(1<<KEY_UP)|(1<<KEY_DOWN)|(1<<KEY_ENTER);
	
	//BEC: Setez pinul PD7 ca iesire
	DDRD |= (1 << PD7);
	//BEC: Sting LED-ul
	PORTD |= (1 << PD7);

}

void draw_matrix(int matrix[33]){
	int i,j;
	for (i = 1; i < 8; i++)
		for (j = 1; j < 8; j++){
			color = matrix[(i - 1) * 8 + j];
			drawPixel(i, j);		
	}
	Transfer();
}

int main(void) 
{
	
	init_io();
	init();
		
	PORTD |= (1 << 7);
	_delay_ms(2000);
	PORTD &= ~(1 << PD7);
	int i, j, aux;
	int col[9];
	int verif[65];
	for (i = 1; i <= 8; i++)
		col[i] = 0;
	point = !point;
   scrollString(start_msg, point);
   Transfer();
   _delay_ms(100);

	int col1, col2;
	col1 = rand()%7;
	col2 = rand()%7;
	while (!col1)
		col1 = rand()%7;
	while (!col2)
		col2 = rand()%7;
	while (col1 == col2)
		col2 = rand()%7;

	for (i = 1; i <= 8; i++)
		for (j = 1; j <= 8; j++){
			aux = rand() % 7;
			while (aux == 0 || ( col[aux] > 9 && (aux != col1 && aux != col2))
				|| ( col[aux] > 11 && (aux == col1 || aux == col2)))
				aux = rand() % 7;
			col[aux]++;
			verif[i * 8 + j] = aux;
			color = aux;
			//drawPixel(i, j);
		}
	for (i = 1; i <= 8; i++)
		for (j = 1; j <= 8; j++){
			color = 7;
			drawPixel(i, j);
		}
	Transfer();
	_delay_ms(500);
	vClear();
	Transfer();
	
	int x = 1, y = 1;
	int new[65];
	for (i = 1; i <= 65; i++)
		new[i] = 0;
	int tiles_up = 0;
	int temp[3];
	temp[1] = 0;
	temp[2] = 0;
	int x1, x2, y1, y2;
	vClear();
	draw_matrix(new);
	_delay_ms(500);
	x1 = 0;
	x2 = 0;
	y1 = 0;
	y2 = 0;
	for (;;){
		// PB0 apasat
		vClear();
		draw_matrix(new);
		if (x1 && y1){
			color = temp[1];
			drawPixel(x1, y1);
		}
		if (x2 && y2){
			color = temp[2];
			drawPixel(x2, y2);
		}
		color = 7;
		drawPixel(x, y);
		Transfer();
		if((KEY_PIN & (1 << KEY_RIGHT)) == 0)
		{
			PORTD |= (1 << PD7);
			vClear();
			draw_matrix(new);
			if (y < 8)
				y++;
			else y = 0;
			color = 7;
			drawPixel(x, y);
			if (x1 && y1){
				color = temp[1];
				drawPixel(x1, y1);
			}
			if (x2 && y2){
				color = temp[2];
				drawPixel(x2, y2);
			}
			Transfer();
		}
		else
		// Sting LED-ul.
		PORTD &= ~(1 << PD7);
		
		if((KEY_PIN & (1 << KEY_LEFT)) == 0)
		{
			PORTD |= (1 << PD7);
			vClear();
			draw_matrix(new);
			if (y > 1)
				y--;
			else y = 0;
			color = 7;
			drawPixel(x, y);
			if (x1 && y1){
				color = temp[1];
				drawPixel(x1, y1);
			}
			if (x2 && y2){
				color = temp[2];
				drawPixel(x2, y2);
			}
			Transfer();
		}
		else
		// Sting LED-ul.
		PORTD &= ~(1 << PD7);
		
		if((KEY_PIN & (1 << KEY_UP)) == 0)
		{
			PORTD |= (1 << PD7);
			vClear();
			draw_matrix(new);
			if (x > 0)
				x--;
			else x = 8;
			color = 7;
			drawPixel(x, y);
			if (x1 && y1){
				color = temp[1];
				drawPixel(x1, y1);
			}
			if (x2 && y2){
				color = temp[2];
				drawPixel(x2, y2);
			}
			Transfer();
		}
		else
		// Sting LED-ul.
		PORTD &= ~(1 << PD7);
		
		if((KEY_PIN & (1 << KEY_DOWN)) == 0)
		{
			PORTD |= (1 << PD7);
			vClear();
			draw_matrix(new);
			if (x < 8)
				x++;
			else x = 0;
			color = 7;
			drawPixel(x, y);
			if (x1 && y1){
				color = temp[1];
				drawPixel(x1, y1);
			}
			if (x2 && y2){
				color = temp[2];
				drawPixel(x2, y2);
			}
			Transfer();
		}
		else
		// Sting LED-ul.
		PORTD &= ~(1 << PD7);
		
		if((KEY_PIN & (1 << KEY_ENTER)) == 0)
		{
			PORTD |= (1 << PD7);
			vClear();
			draw_matrix(new);
			if (tiles_up == 0){
				x1 = x;
				y1 = y;
				temp[1] = verif[(x - 1) * 8 + y];
				color = verif[(x - 1) * 8 + y];
				drawPixel(x, y);
				Transfer();
				tiles_up++;
			}
			else{
				if (tiles_up == 1){
					x2 = x;
					y2 = y;
					temp[2] = verif[(x - 1) * 8 + y];
					color = verif[(x - 1) * 8 + y];
					drawPixel(x, y);
					Transfer();
					if (temp[1] == temp[2]){
						new[(x1-1) * 8 + y1] = verif[(x1-1) * 8 + y1];
						new[(x2-1) * 8 + y2] = verif[(x2-1) * 8 + y2];
						tiles_up = 0;
						x1 = 0;
						x2 = 0;
						y1 = 0;
						y2 = 0;
						temp[1] = 0;
						temp[2] = 0;
					}
					else
						tiles_up++;
				}
				else{
					temp[2] = 0;
					x1 = x;
					y1 = y;
					x2 = 0;
					y2 = 0;
					temp[2] = 0;
					temp[1] = verif[(x - 1) * 8 + y];
					color = verif[(x - 1) * 8 + y];
					drawPixel(x, y);
					if (x2 && y2){
						color = temp[2];
						drawPixel(x2, y2);
					}
					Transfer();
					tiles_up = 1;
				}
			}

		}
		else
		// Sting LED-ul.
		PORTD &= ~(1 << PD7);
		
		_delay_ms(150);

	}
	return 0;
}

	
	/*	/ Daca butonul este apasat
		if (((KEY_PIN & (1 << KEY_1)) == 0) | ((KEY_PIN & (1 << KEY_2)) == 0) 
			| ((KEY_PIN & (1 << KEY_3)) == 0) | ((KEY_PIN & (1 << KEY_4)) == 0)
			| ((KEY_PIN & (1 << KEY_5)) == 0))
		/* Aprind LED-ul
		PORTD |= (1 << PD7);
		else
		/* Sting LED-ul.
		PORTD &= ~(1 << PD7);*/