/*
 * spi.h
 *
 * Created: 5/26/2016 11:35:29 PM
 *  Author: Nazi4life
 */ 


#ifndef SPI_H_
#define SPI_H_

#include <stdio.h>
#include <util/delay.h>
#include <avr/io.h>

#define SPI_CLOCK_DIV4 0x00
#define SPI_CLOCK_DIV16 0x01
#define SPI_CLOCK_DIV64 0x02
#define SPI_CLOCK_DIV128 0x03
#define SPI_CLOCK_DIV2 0x04
#define SPI_CLOCK_DIV8 0x05
#define SPI_CLOCK_DIV32 0x06
//#define SPI_CLOCK_DIV64 0x07

#define SPI_MODE0 0x00
#define SPI_MODE1 0x04
#define SPI_MODE2 0x08
#define SPI_MODE3 0x0C

#define SPI_MODE_MASK 0x0C  // CPOL = bit 3, CPHA = bit 2 on SPCR0
#define SPI_CLOCK_MASK 0x03  // SPR1 = bit 1, SPR0 = bit 0 on SPCR0
#define SPI_2XCLOCK_MASK 0x01  // SPI2X = bit 0 on SPSR

#define SS PB4
#define MOSI PB5
#define MISO PB6
#define SCK PB7

static char transfer(char _data);
static void attachInterrupt();
static void detachInterrupt(); // Default

// SPI Configuration
void begin(); // Default
void end();
void setBitOrder(uint8_t);
void setDataMode(uint8_t);
void setClockDivider(uint8_t);



char transfer(char _data) 
{
	SPDR0 = _data;
	while (!(SPSR0 & _BV(SPIF0)))	;
	return SPDR0;
}

void attachInterrupt() 
{
	SPCR0 |= _BV(SPIE0);
}

void detachInterrupt() 
{
	SPCR0 &= ~_BV(SPIE0);
}




#endif /* SPI_H_ */